#ifndef INCLUDED_DT_STREAM_BASE_H
#define INCLUDED_DT_STREAM_BASE_H

#include "dt_stream.h"

/** Internal data structure for instances of the dt_reader base class */
typedef struct dt_reader_
{
   /** Destructor function called to delete an instance */
   void    (*free_impl)( dt_reader* obj );
   /** Function used to retrieve a streaming step */
   dt_bool (*read_impl)( dt_reader* obj, dt_stream_step* step );
} dt_reader;

/** Internal data structure for instances of the dt_writer base class */
typedef struct dt_writer_
{
   /** Destructor function called to delete an instance */
   void    (*free_impl )( dt_writer* obj );
   /** Function used to process an incoming streaming step */
   dt_bool (*write_impl)( dt_writer* obj, dt_stream_step const* step );
} dt_writer;



void dt_init_reader_base( dt_reader* reader
                        , void (*free_impl)(dt_reader*)
                        , dt_bool (*read_impl)(dt_reader*, dt_stream_step*)
                        );
void dt_init_writer_base( dt_writer* writer
                        , void (*free_impl)(dt_writer*)
                        , dt_bool (*write_impl)(dt_writer*, dt_stream_step const*)
                        );


#endif/*INCLUDED_DT_STREAM_BASE_H*/

