/** @file
    @brief  Functions converting C types to/from datatree nodes (dt_node).
*/
#ifndef INCLUDED_DT_VALUE_H
#define INCLUDED_DT_VALUE_H

#include "dt_type.h"


dt_node* dt_make_bool ( int b );   // --> YES or NO strings
dt_node* dt_make_int  ( long i );
dt_node* dt_make_uint ( unsigned long u );
dt_node* dt_make_float( double f );

dt_node* dt_make_str  ( const char* s );


dt_bool  dt_read_bool ( dt_node const* node, int*  b  );
dt_bool  dt_read_int  ( dt_node const* node, long* i );
dt_bool  dt_read_uint ( dt_node const* node, unsigned long* u );
dt_bool  dt_read_float( dt_node const* node, double* f );

dt_bool  dt_read_strn   ( dt_node const* node, char* buf, size_t bufSize );
dt_bool  dt_read_str_dyn( dt_node const* node, char** s );


#endif/*INCLUDED_DT_VALUE_H*/
